//*****************************************************************************
//
// Simple Touch-based particle script.
//
// Use: Touching the prim containing this script will turn the particle system
// on and off.
//
//*****************************************************************************

ParticleStart()
{
    llParticleSystem([
        PSYS_PART_FLAGS, 259,
        PSYS_SRC_PATTERN, 8,
        PSYS_PART_START_ALPHA, 0.8, //0.66
        PSYS_PART_END_ALPHA, 0.00,
        PSYS_PART_START_COLOR, <0.0,0.0,1.0>,
        PSYS_PART_END_COLOR, <0.3,0.3,0.5>,
        PSYS_PART_START_SCALE, <0.5,0.5,0.00>, // was 1,1,0
        PSYS_PART_END_SCALE, <0.25,0.25,0.00>,  // was 0.5,0.5,0
        PSYS_PART_MAX_AGE, 30.00,
        PSYS_SRC_MAX_AGE, 0.00,
        PSYS_SRC_ACCEL, <0.00,0.00,0.00>,
        PSYS_SRC_ANGLE_BEGIN, 0.00,
        PSYS_SRC_ANGLE_END, 3.14,
        PSYS_SRC_BURST_PART_COUNT, 10,
        PSYS_SRC_BURST_RADIUS, 25.00,
        PSYS_SRC_BURST_RATE, 0.20,
        PSYS_SRC_BURST_SPEED_MIN, 0.00,
        PSYS_SRC_BURST_SPEED_MAX, 0.00,
        PSYS_SRC_OMEGA, <0.00,0.00,0.00>,
        PSYS_SRC_TEXTURE, "0c28f92b-b401-42f3-8c7e-d123b319ea3e"
        // Was smoke "b6cd4877-d801-426d-92c9-b01ba6184b52"
        // Was "f9ecf728-2fc3-f7c1-2125-e53e1e998ec8"
    ]);

}

ParticleStop()
{
    llParticleSystem([]);
}


//*****************************************************************************
//
// Default state: LSL will always start in this state.
//
// Immediately go to the 'On' state.
//
//*****************************************************************************

default
{
    state_entry()
    {
        state On;
    }
}


//*****************************************************************************
//
// On state: Starts the particle system when this state is entered.
//
// Transitions to the 'Off' state when this prim is touched.
//
//*****************************************************************************

state On
{
    state_entry()
    {
        ParticleStart();
        llSay(0,"Particles On");
    }

    touch_start(integer total_number)
    {
        if (llSameGroup(llDetectedKey(0)))
            state Off;
        else
            llSay(0, "Wrong active group!");
    }
}


//*****************************************************************************
//
// Off state: Stops the particle system when this state is entered.
//
// Transitions to the 'On' state when this prim is touched.
//
//*****************************************************************************

state Off
{
    state_entry()
    {
        ParticleStop();
        llSay(0,"Particles Off");
    }

    touch_start(integer total_number)
    {
                if (llSameGroup(llDetectedKey(0)))
            state On;
        else
            llSay(0, "Wrong active group!");
    }
}
